unit USimpleDemo1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, ExtCtrls;

type
  TDemoForm1 = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    Demo1: TMenuItem;
    DateTimeValue: TMenuItem;
    Label1: TLabel;
    ChangeValueButton: TButton;
    NodeText: TMenuItem;
    ValueMemo: TMemo;
    N1: TMenuItem;
    AttributeValueText: TMenuItem;
    AttributeDateTime: TMenuItem;
    AttributeHex: TMenuItem;
    AttributeFloat: TMenuItem;
    procedure NodeTextClick(Sender: TObject);
    procedure ChangeText(Sender: TObject);
    procedure ChangeDateTime(Sender: TObject);
    procedure DateTimeValueClick(Sender: TObject);
    procedure AttributeValueTextClick(Sender: TObject);
    procedure ChangeAttributText(Sender: TObject);
    procedure AttributeDateTimeClick(Sender: TObject);
    procedure ChangeAttributDateTime(Sender: TObject);
    procedure AttributeHexClick(Sender: TObject);
    procedure ChangeAttributHex(Sender: TObject);
    procedure AttributeFloatClick(Sender: TObject);
    procedure ChangeAttributFloat(Sender: TObject);
  private
  public
    { Public-Deklarationen }
  end;

var
  DemoForm1: TDemoForm1;

implementation

{$R *.dfm}

uses
  SimpleXML;

var
  DemoDoc: IXmlDocument;
  DemoNode: IXMLNode;

procedure TDemoForm1.ChangeText(Sender: TObject);
begin
  DemoNode.Text := ValueMemo.Text;
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.AttributeDateTimeClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Clear;
  ValueMemo.Lines.Add(DateToStr(Date));
  ValueMemo.Lines.Add(TimeToStr(Time));
  // Prepare Button
  ChangeValueButton.OnClick := ChangeAttributDateTime;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Get root node
  DemoNode := DemoDoc.DocumentElement;
  // Start ChangeAttributText
  ChangeValueButton.OnClick(nil);
end;

procedure TDemoForm1.AttributeFloatClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Text := FloatToStr(123.456);
  // Prepare Button
  ChangeValueButton.OnClick := ChangeAttributFloat;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Get root node
  DemoNode := DemoDoc.DocumentElement;
  // Start ChangeAttributText
  ChangeValueButton.OnClick(nil);
end;

procedure TDemoForm1.AttributeHexClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Text := '1234ABCD';
  // Prepare Button
  ChangeValueButton.OnClick := ChangeAttributHex;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Get root node
  DemoNode := DemoDoc.DocumentElement;
  // Start ChangeAttributText
  ChangeValueButton.OnClick(nil);
end;

procedure TDemoForm1.AttributeValueTextClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Text := 'Demo Text';
  // Prepare Button
  ChangeValueButton.OnClick := ChangeAttributText;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Get root node
  DemoNode := DemoDoc.DocumentElement;
  // Start ChangeAttributText
  ChangeValueButton.OnClick(nil);
end;

procedure TDemoForm1.ChangeAttributDateTime(Sender: TObject);
var
  Value: TDateTime;
begin
  if ValueMemo.Lines.Count<2
  then begin
    ShowMessage('Date and Time in two consecutive lines needed!');
    exit;
  end;
  //First line should be date
  Value := StrToDate(ValueMemo.Lines[0]);
  //Second line should be time
  Value := Value + StrToTime(ValueMemo.Lines[1]);
  DemoNode.SetDateTimeAttr('MyDemoAttribut', Value);
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.ChangeAttributFloat(Sender: TObject);
begin
  DemoNode.SetFloatAttr('MyDemoAttribut', StrToFloat(ValueMemo.Text));
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.ChangeAttributHex(Sender: TObject);
begin
  DemoNode.SetHexAttr('MyDemoAttribut', StrToInt('$' + ValueMemo.Text));
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.ChangeAttributText(Sender: TObject);
begin
  DemoNode.SetAttr('MyDemoAttribut', ValueMemo.Text);
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.ChangeDateTime(Sender: TObject);
begin
  if ValueMemo.Lines.Count<2
  then begin
    ShowMessage('Date and Time in two consecutive lines needed!');
    exit;
  end;
  //First line should be date
  DemoNode.TypedValue := StrToDate(ValueMemo.Lines[0]);
  //Second line should be time
  DemoNode.TypedValue := DemoNode.TypedValue + StrToTime(ValueMemo.Lines[1]);
  // Load resulting XML document to Memo1
  Memo1.Text := DemoDoc.XML;
end;

procedure TDemoForm1.DateTimeValueClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Clear;
  ValueMemo.Lines.Add(DateToStr(Date));
  ValueMemo.Lines.Add(TimeToStr(Time));
  // Prepare Button
  ChangeValueButton.OnClick := ChangeDateTime;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Find root node
  DemoNode := DemoDoc.DocumentElement;
  // Set text of root node "document"
  ChangeValueButton.OnClick(nil);
end;

procedure TDemoForm1.NodeTextClick(Sender: TObject);
begin
  { ---- Prepare Demo ---- }
  // Prepare value
  ValueMemo.Text := 'Demo Text';
  // Prepare Button
  ChangeValueButton.OnClick := ChangeText;
  ChangeValueButton.Enabled := True;

  { ---- Start Demo ---- }
  // Create xml document with root node "document"
  DemoDoc := CreateXmlDocument('document');
  // Find root node
  DemoNode := DemoDoc.DocumentElement;
  // Set text of root node "document"
  ChangeValueButton.OnClick(nil);
end;

end.
